----------------------------------------------------------------------------------
-- Module Name: dac16 - Behavioral 
-- Author:	Mike Field (hamster@snap.net.nz)
-- Revision:	1.0
--
--
-- A quick and dirty 1bit DAC, based on details at http://fpga4fun.com
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity dac16 is
    Port ( clk : in  STD_LOGIC;
           data : in  STD_LOGIC_VECTOR (15 downto 0);
           dac_out : out  STD_LOGIC);
end dac16;

architecture Behavioral of dac16 is
  signal sum : STD_LOGIC_VECTOR (16 downto 0) := "01000000000000000";
begin
	
  dac_out <= sum(16);
	
  process (Clk, sum)
	
  begin
		
    if Clk'Event and Clk = '1' then
      -- Don't forget to flip data(15) to convert it to an unsinged int value
	
      sum <= ("0" & sum(15 downto 0)) + ("0" & (not data(15)) & data(14 downto 0));

    end if;
	
  end process;
end Behavioral;

