----------------------------------------------------------------------------------
-- Module Name: resync - Behavioral 
-- Author:	Mike Field (hamster@snap.net.nz)
-- Revision:	1.0
--
--
-- Condition the incoming singnal, and output a pulse when it changes.
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity resync is
    Port ( clk 		: in  STD_LOGIC;
           pulse 		: in  STD_LOGIC;
           flipped	: out STD_LOGIC;
			  synced		: out	STD_LOGIC);
end resync;

architecture Behavioral of resync is
	signal ff1,ff2 : std_logic;
begin
	flipped <= ff1 xor ff2;
	synced <= ff2;
	
	process (clk, pulse, ff1, ff2)
	begin
		if clk'event and clk = '1' then
			ff2 <= ff1;
			ff1 <= pulse;
		end if;
	end process;
end Behavioral;

