LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
ENTITY testbench IS
END testbench;
 
ARCHITECTURE behavior OF testbench IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT spdifCapture
    PORT(
         clk : IN  std_logic;
         pulse : IN  std_logic;
         dac_left_out : OUT  std_logic;
         dac_right_out : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal pulse : std_logic := '0';

 	--Outputs
   signal dac_left_out : std_logic;
   signal dac_right_out : std_logic;
   signal valid : std_logic;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
	signal ring : std_logic_vector(127 downto 0) := "11101000"  -- preamble (1st Channel, start of frame)
																& "10101100"  -- sample 23-20
																& "10101010"  -- sample 19-16
																& "10101010"  -- sample 15-12
																& "10101010"  -- sample 11- 8
																& "10101010"  -- sample  7- 4
																& "10101010"  -- sample  3- 0
																& "10101010"  -- subcodfe/sc,parity;
																& "11100100"  -- preamble (2nd channel)
																& "10101100"  -- sample 23-20
																& "10101010"  -- sample 19-16
																& "10101010"  -- sample 15-12
																& "10101010"  -- sample 11- 8
																& "10101010"  -- sample  7- 4
																& "11001100"  -- sample  3- 0
																& "10101010"; -- subcodfe/sc,parity;
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: spdifCapture PORT MAP (
          clk => clk,
          pulse => pulse,
          dac_left_out => dac_left_out,
          dac_right_out => dac_right_out
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 
	pulse <= ring(63);
   -- Stimulus process
   stim_proc: process
   begin		
      -- insert stimulus here 
		wait for 354 ns;
		ring <= ring(126 downto 0) & ring(127);
   end process;

END;
